////////////////////////////////////////////////
//   _O2M_ppp.h  _O2M_ppp.cpp //
////////////////////////////////////////////////

#include "xml_lib.h"
#include "linkage.h"

//-----------------------------------------------------------------------------
//     
const char* const comment_line_cpp = "///////////////////////////////////////////////\n";
const char* const comment_title = "This file was generated by Link2M utility";
const char* const comment_format = "%s// %s //\n%s\n";


//-----------------------------------------------------------------------------
//    
extern FILE* output;


//-----------------------------------------------------------------------------
//  .2ml ,  false      ,
//FileFound -    
bool proceed_file(const char* FName, CCaseSumm* CaseSumm, CCommonProcSumm* CommonProcSumm, bool* FileFound)
{
	//   
	*FileFound = false;

	//  .2ml  ( )
	CXMLFile xmlFile;
	if (EXMLNoError != xmlFile.Load(FName)) return true;

	//  
	*FileFound = true;

	//     XML 
	if (strcmp("Module", xmlFile.XMLEntry->TagName)) {
		fprintf(output, "WARNING: Not found module description in file \"%s\"\n", FName);
		return true;
	}

	//     
	CXMLEntry::TXMLEntryStore::const_iterator ci;
	for (ci = xmlFile.XMLEntry->XMLEntryStore.begin(); ci != xmlFile.XMLEntry->XMLEntryStore.end(); ci++) {
		//  
		if (!strcmp("Case", (*ci)->TagName)) {
			if (!CaseSumm->AddCase(*ci, xmlFile.XMLEntry->AttribValue("Name"))) goto fault_exit;
		} else
		//   
		if (!strcmp("CProc", (*ci)->TagName)) {
			if (!CommonProcSumm->AddCommonProc(*ci, xmlFile.XMLEntry->AttribValue("Name"))) goto fault_exit;
		} else
		//    
		if (!strcmp("HProc", (*ci)->TagName))
			if (!CommonProcSumm->AddHandlerProc(*ci, xmlFile.XMLEntry->AttribValue("Name"))) goto fault_exit;
	}

	//    (All OK)
	return true;

fault_exit:
	//     
	fprintf(output, "ERROR: File \"%s\" - FAILED\n", FName);
	return false;
}


//-----------------------------------------------------------------------------
//  _O2M_ppp.*
bool gen_ppp_files(const CXMLEntry* xmlEntry, const char* const path2ml, const char* pathPPP)
{
	//       
	const char* const ext2ml = ".2ml";
	const int len2ml = strlen(ext2ml) + strlen(path2ml) + 1;
	const char* Path;
	const char* File;
	char FName[xml_lib::BufSize];

	//    
	const char* st_too_long = "WARNING: File name too long: \"%s\"\n";
	const char* st_writing = "ERROR: Cannot open file \"%s\" for writing\n";

	//      
	const char* O2M_ppp_h = "_O2M_ppp.h";
	const char* O2M_ppp_cpp = "_O2M_ppp.cpp";
	const int len_O2M_ppp_cpp = strlen(O2M_ppp_cpp) + 2;

	//       (  -   )
	if (!pathPPP) pathPPP = path2ml;
	int len_ppp = strlen(pathPPP);

	//     
	if (xml_lib::BufSize < len_ppp + len_O2M_ppp_cpp) {
		fprintf(output, "ERROR: Path to output files too long\n");
		return false;
	}

	//   
	bool FileFound;

	//     
	CCaseSumm CaseSumm;
	//        
	CCommonProcSumm CommonProcSumm;

	//   
	CXMLEntry::TXMLEntryStore::const_iterator ci;
	for (ci = xmlEntry->XMLEntryStore.begin(); ci != xmlEntry->XMLEntryStore.end(); ci++)
		if (!strcmp("File", (*ci)->TagName)) {
			//  ,   ( )
			File = (*ci)->AttribValue("Name");
			if (!File) continue;
			Path = (*ci)->AttribValue("Path");
			//    
			int len = strlen(File) + len2ml;
			if (Path) len += strlen(Path);
			//       
			if (xml_lib::BufSize < len) {
				fprintf(output, st_too_long, File);
				continue;
			}
			//  
			if (Path) {
				strcpy(FName, Path);
				strcat(FName, path2ml);
			} else
				strcpy(FName, path2ml);
			strcat(FName, File);
			strcat(FName, ext2ml);
			//     .2ml 
			if (!proceed_file(FName, &CaseSumm, &CommonProcSumm, &FileFound)) return false;
		}

	//    (    )
	File = xmlEntry->AttribValue("Main");
	if (!File)
		fprintf(output, "WARNING: Not specified main file in project\n");
	else
		if (xml_lib::BufSize < strlen(File) + len2ml)
			fprintf(output, st_too_long, File);
		else {
			//  
			strcpy(FName, path2ml);
			strcat(FName, File);
			strcat(FName, ext2ml);
			//     .2ml 
			if (!proceed_file(FName, &CaseSumm, &CommonProcSumm, &FileFound)) return false;
			//   .2ml 
			if (!FileFound) fprintf(output, "WARNING: Not found file \"%s\"\n", FName);
		}

	//   
	if (!CaseSumm.CheckIntegrity()) return false;
	//      
	if (!CommonProcSumm.CheckIntegrity(&CaseSumm)) return false;

	//   _O2M_ppp.h
	strcpy(FName, pathPPP);
	--len_ppp;
	if (0 < len_ppp && '/' != FName[len_ppp] && '\\' != FName[len_ppp]) {
		FName[len_ppp + 1] = '/';
		FName[len_ppp + 2] = '\0';
	}
	strcat(FName, O2M_ppp_h);
	//    _O2M_ppp.h
	FILE* fh = fopen(FName, "w");
	if (!fh) {
		fprintf(output, st_writing, FName);
		return false;
	}
	//   _O2M_ppp.cpp
	len_ppp = strlen(FName);
	FName[len_ppp - 1] = 'c';
	FName[len_ppp] = 'p';
	FName[len_ppp + 1] = 'p';
	FName[len_ppp + 2] = '\0';
	//    _O2M_ppp.cpp
	FILE* fc = fopen(FName, "w");
	if (!fc) {
		fprintf(output, st_writing, FName);
		fclose(fh);
		return false;
	}

	//    
    fprintf(fc, comment_format, comment_line_cpp, comment_title, comment_line_cpp);
    fprintf(fh, comment_format, comment_line_cpp, comment_title, comment_line_cpp);

	//  
	CaseSumm.WriteCPP(xmlEntry, fh, fc);
	//       
	CommonProcSumm.WriteCPP(fh, fc, &CaseSumm);

	//   _O2M_ppp.* 
	fclose(fh);
	fclose(fc);
	return true;
}
